#define range(a,b,c) ((a)<(b) ? (b) : ( (a)>(c) ? (c) : (a) ))
#define limiter(a,b,c) if (a<(b)) a=(b); else if ( a>(c)) a=(c);

#ifdef DEBUG
#define DebugOut(tekst) OutputDebugString(tekst);
#define DebugOut1(tekst,a) { char napis[256]; StringCbPrintf(napis,256,tekst,a); OutputDebugString(napis); }
#define DebugOut2(tekst,a,b) { char napis[256]; StringCbPrintf(napis,256,tekst,a,b); OutputDebugString(napis); }
#define DebugOut3(tekst,a,b,c) { char napis[256]; StringCbPrintf(napis,256,tekst,a,b,c); OutputDebugString(napis); }
#define ErrorOut(tekst) OutputDebugString(tekst);
#define ErrorOut1(tekst,a) { char napis[256]; StringCbPrintf(napis,256,tekst,a); OutputDebugString(napis); }
#define ErrorOut2(tekst,a,b) { char napis[256]; StringCbPrintf(napis,256,tekst,a,b); OutputDebugString(napis); }
#define ErrorOut3(tekst,a,b,c) { char napis[256]; StringCbPrintf(napis,256,tekst,a,b,c); OutputDebugString(napis); }
#else
#define DebugOut(tekst)
#define DebugOut1(tekst,a)
#define DebugOut2(tekst,a,b)
#define DebugOut3(tekst,a,b,c)
#define ErrorOut(tekst)
#define ErrorOut1(tekst,a)
#define ErrorOut2(tekst,a,b)
#define ErrorOut3(tekst,a,b,c)
#endif

/////////////////////////////////
struct CPoint
{
	int x;
	int y;
};
/////////////////////////////////
class CFont
{
private:
	HFONT m_handle;

public:
	CFont() { m_handle=0; }
	~CFont() { if (m_handle) Destroy(); }
	void Destroy() { DeleteObject(m_handle); }
	void Create(int height,int width,int weight,DWORD italic,DWORD underline,LPCTSTR face) { m_handle=CreateFont(height,width,0,0,weight,italic,underline,0,0,0,0,0,0,face); }
	HFONT Select(HDC hDC) { return (HFONT)SelectObject(hDC,m_handle); }
};
/////////////////////////////////
class CRegistry
{
	HKEY m_handle;
public:
	CRegistry() { m_handle=0; }
	int OpenForRead(HKEY root, char *subkey);
	int OpenForWrite(HKEY hRoot, char *subkey);
	void Close() { RegCloseKey(m_handle); }
	void GetInteger(char *name, int *val);
	void GetLimitedInteger(char *name, int *val, int min, int max);
	void SetInteger(char *name, int val);
	void GetDouble(char *name, double *val);
	void GetLimitedDouble(char *name, double *val, double nin, double max);
	void SetDouble(char *name, double val);
	void GetText(char *name, char *val, DWORD size);
	void SetText(char *name, char *val);
};
/////////////////////////////////
BOOL CALLBACK DialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
/////////////////////////////////
class CDialog
{
protected:
	HWND m_handle;

public:
	virtual BOOL OnInitDialog(HWND hWnd) {  DebugOut("c2\n"); m_handle=hWnd; return TRUE; }
	virtual BOOL OnOk() { EndDialog(m_handle, IDOK); return TRUE; }
	virtual BOOL OnCancel() { EndDialog(m_handle, IDCANCEL); return TRUE; }
	virtual BOOL OnNotify(int /*id*/, NMHDR * /*hdr*/) { return FALSE; }
	virtual BOOL OnCommand(int /*id*/, int /*notify*/, HWND /*control*/) { return FALSE; }

	int Execute(HWND parent, int id)
		{ 	DebugOut3("c1 %d %d %d\n",parent,id,this); return DialogBoxParam((HINSTANCE)GetWindowLong(parent,GWL_HINSTANCE), MAKEINTRESOURCE(id) , parent, (DLGPROC)DialogProc, (LPARAM)this); }
	LRESULT SendMessage(int nID, UINT uMsg, WPARAM wParam, LPARAM lParam) { return SendDlgItemMessage(m_handle,nID,uMsg,wParam,lParam); }
	void SetText(int nID, char *cText) { SetDlgItemText(m_handle,nID,cText); }
	UINT GetText(int nID, char *cText, int nSize) { return GetDlgItemText(m_handle,nID,cText,nSize); }
	void SetInteger(int nID, int nVal) { SetDlgItemInt(m_handle,nID,nVal,TRUE); }
	BOOL GetInteger(int nID, int *nVal);
	BOOL GetLimitedInteger(int nID, int *nVal, int nMin, int nMax);
	void SetDouble(int nID, double fVal);
	BOOL GetDouble(int nID, double *fVal);
	BOOL GetLimitedDouble(int nID, double *fVal, double fMin, double fMax);
	void SetFocus(int nID) { ::SetFocus(GetDlgItem(m_handle,nID)); }
	void SetRadio(int nID, int nRange, int nVal) { CheckRadioButton(m_handle, nID, nID+nRange-1, nID+nVal); }
	BOOL GetRadio(int nID, int nRange, int *nVal);
	void SetCheck(int nID, int nVal) { SendMessage(nID,BM_SETCHECK,nVal,0); }
	void GetCheck(int nID, int *nVal) { *nVal=SendMessage(nID,BM_GETCHECK,0,0); }
	void GetSelectedItem(int nID, int *nVal);
	void Enable(int nID) { EnableWindow(GetDlgItem(m_handle,nID),TRUE); }
	void Enable(int nID, int con) { EnableWindow(GetDlgItem(m_handle,nID),con); }
	void Disable(int nID) { EnableWindow(GetDlgItem(m_handle,nID),FALSE); }
};
/////////////////////////////////
class CWnd
{
public:
	HWND   m_handle;

public:
	CWnd() { m_handle=0; }
	virtual int Create(int /*x*/, int /*y*/, int /*w*/, int /*h*/, HWND /*parent*/, DWORD /*style*/) { return 0; }
	virtual void Destroy() { DestroyWindow(m_handle); }
	virtual int OnCreate(LPCREATESTRUCT /*create_struct*/) { return 0; }		//tworzenie okna si udao;
	virtual void OnDestroy() {}
	virtual BOOL OnClose() { return TRUE; }
	virtual void OnSize(UINT /*type*/, UINT /*width*/, UINT /*height*/) {}
	virtual void OnPaint(HDC /*hDC*/) {}
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam) { return DefWindowProc(m_handle, WM_COMMAND, wParam, lParam); }
	virtual LRESULT OnUser(UINT /*msg*/, WPARAM /*wParam*/, LPARAM /*lParam*/) { return 0; }
	virtual void OnVScroll(int /*scroll_code*/, int /*pos*/, HWND /*scroll_bar*/) {}
	virtual void OnHScroll(int /*scroll_code*/, int /*pos*/, HWND /*scroll_bar*/) {}
	virtual void OnTimer(UINT /*id*/) {}
	virtual LRESULT OnChar(TCHAR chCharCode, LPARAM lKeyData) { return DefWindowProc(m_handle, WM_CHAR, chCharCode, lKeyData); }
	virtual LRESULT OnKeyDown(int nVirtKey, LPARAM lKeyData) { return DefWindowProc(m_handle, WM_KEYDOWN, nVirtKey, lKeyData); }
	virtual LRESULT OnKeyUp(int nVirtKey, LPARAM lKeyData) { return DefWindowProc(m_handle, WM_KEYDOWN, nVirtKey, lKeyData); }
	virtual void OnSetFocus() {}
	virtual void OnKillFocus() {}
	virtual void OnMouseMove(int /*nKeys*/, int /*nXPos*/, int /*nYPos*/) {}
	virtual void OnLButtonDown(int /*nKeys*/, int /*nXPos*/, int /*nYPos*/) {}
	virtual void OnLButtonUp(int /*nKeys*/, int /*nXPos*/, int /*nYPos*/) {}
	virtual void OnRButtonDown(int /*nKeys*/, int /*nXPos*/, int /*nYPos*/) {}
	virtual void OnRButtonUp(int /*nKeys*/, int /*nXPos*/, int /*nYPos*/) {}
	void SetWindowHandle(HWND hWnd) { m_handle = hWnd; SetWindowLong(hWnd,0,(long)this); }
	void Invalidate(BOOL erase) { InvalidateRect(m_handle,NULL,erase); }
	void Move(int x, int y, int w, int h, BOOL repaint) { MoveWindow(m_handle,x,y,w,h,repaint); }
	void SetTitle(char *new_title) { SetWindowText(m_handle,new_title); }
};
/////////////////////////////////
class CMDIChildWnd : public CWnd
{
public:
	CMDIChildWnd() : CWnd()	{}
	virtual int Create(int x, int y, int w, int h, HWND parent, DWORD style);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam) { return DefMDIChildProc(m_handle, WM_COMMAND, wParam, lParam); }
	virtual LRESULT OnChar(TCHAR chCharCode, LPARAM lKeyData) { return DefMDIChildProc(m_handle, WM_CHAR, chCharCode, lKeyData); }
	virtual LRESULT OnKeyDown(int nVirtKey, LPARAM lKeyData) { return DefMDIChildProc(m_handle, WM_KEYDOWN, nVirtKey, lKeyData); }
	virtual LRESULT OnKeyUp(int nVirtKey, LPARAM lKeyData) { return DefMDIChildProc(m_handle, WM_KEYUP, nVirtKey, lKeyData); }
	virtual LRESULT OnMDIActivate(HWND hLast, HWND hNew) { return DefMDIChildProc(m_handle, WM_MDIACTIVATE, (WPARAM)hLast, (LPARAM)hNew); }
};
/////////////////////////////////
LRESULT FAR PASCAL WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT FAR PASCAL MDIChildWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
