//////////////////////////////////////
class CAproxData : public CThreadData
{
public:
	double m_rate;
	int m_components;
	double m_fr[MAX_OMEGA];
	double m_Vr[MAX_OMEGA];
	double m_A[MAX_OMEGA];
	double m_D[MAX_OMEGA];
	double m_eta[MAX_OMEGA];
	double m_A0;
	double m_epsilon;
	double m_stop_cond;
	int m_estimate_error;
	double m_observation_error;
	int m_use_AD;
	int m_use_eta;
};
////////////////////////////////////////
class CParametryAproksymacji
{
public:
	int m_use_AD;
	int m_use_eta;
	double m_epsilon;
	double m_break;
	double m_zero;
	int m_estimate_error;
	double m_observation_error;
};

//////////////////////////////////////
class CAprox : public CCalculation
{
	CParametryAproksymacji m_parametry_aproksymacji;

public:
	CAprox(CMeasure *parent, CSelection &selection, CParametryAproksymacji &parametry_aproksymacji);
	void Init();
	void CalcAprox(HWND hParent);
	CParametryAproksymacji *GetAproxParams() { return &m_parametry_aproksymacji; }
	virtual void CopyResults();
};

////////////////////////////////////////
class CParametryAproksymacjiDlg : public CDialog
{
	BOOL m_byly_zmiany;
	CParametrySygnalu *m_params;
	CParametrySygnalu m_new_params;
	CParametryAproksymacji *m_aprox_params;
	CParametryAproksymacji m_new_aprox_params;
	CSelection *m_selection;
	CSelection m_new_selection;

public:
	CParametryAproksymacjiDlg(CParametrySygnalu *params, CParametryAproksymacji *aprox_params, CSelection *selection) : CDialog()
	{ m_params=params; m_new_params=*params; m_aprox_params=aprox_params; m_new_aprox_params=*aprox_params; m_selection=selection; m_new_selection=*selection; }
	int Execute(HWND parent) { return CDialog::Execute(parent, IDD_APROX); }
	virtual BOOL OnInitDialog(HWND hWnd);
	virtual BOOL OnOk();
	virtual BOOL OnNotify(int id, NMHDR *hdr);
	virtual BOOL OnCommand(int id, int notify, HWND control);

private:
	void fill_param(int i);
	void change_settings();
	void create_columns();
	void delete_component();
	void insert_component();
	void insert(int i);
	void copy_all();
};

////////////////////////////////////////
class CAproxWnd : public CMeasureWnd
{
public:
	CAproxWnd() : CMeasureWnd () {}
	virtual int Create(int x, int y, int w, int h, HWND parent, DWORD style);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	virtual int OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual void SetDocument(CMeasure *doc);
};
