#include <windows.h>
#include <strsafe.h>
#include <math.h>

#include "matrix.h"
#include "app.h"
#include "winfi32.h"
#include "resource.h"
#include "measure.h"
#include "calc.h"


///////////////////////////////////////////
void CCalculation::ClearThread()
{
	m_info->m_break=1;
	WaitForSingleObject(m_recalc_thread, INFINITE);
	CloseHandle(m_recalc_thread);
	m_recalc_thread=0;
	SetNumberOfSamples(m_info->m_calculated);
	CopyResults();
}
///////////////////////////////////////////
void CCalculation::StopThread()
{
	if (m_recalc_thread)
		ClearThread();
}

///////////////////////////////////////////

void CCalculation::AddComponent(int channel, int sample)
{
	if (m_parent)
	{
		CParametrySkladowej s;
		StringCbCopy(s.m_name,41,"jaka nazwa");
		s.m_fr=sample/m_rate;   //czestotliwosc
		s.m_A=m_buffer[(channel*m_channels+sample)*2];
		s.m_D=m_buffer[(channel*m_channels+sample)*2+1];
		s.m_eta=0.0;
		s.m_Vr=sqrt(s.m_A*s.m_A+s.m_D*s.m_D);
		s.m_K=5.0;
		m_parent->m_parametry[m_selection.m_channel].AppendComponent(&s);
	}
}

////////////////////////////////////////////////////////
BOOL CCalculation::SaveText(FILE *f)
{
	float *dest;
	int n,i;

	if (m_buffer)
	{
		dest=m_buffer;
		for (i=0;i<m_samples;i++)
		{
			fprintf(f,"%6e",i/m_rate);
			for (n=0;n<m_channels;n++)
			{
				fprintf(f,"\t%6e\t%6e",*dest,*(dest+1));
				dest+=2;
			}
			fprintf(f,"\n");
		}
	}
	return TRUE;
}

