#include <process.h>

//////////////////////////////////////
class CThreadData
{
public:
	float *m_probki;
	float *m_wyniki;
	int m_channel;
	int m_begin;
	int m_samples;
	int m_channels;
	int m_break;		//1-przerywa obliczenia
	HWND m_parent;
	int m_calculated;
public:
	void reset() { m_break=0; m_calculated=0; }
};
//////////////////////////////////////
class CCalculation : public CMeasure
{
	HANDLE m_recalc_thread;

protected:
	CSelection m_selection;
	CThreadData *m_info;
	CMeasure *m_parent;

public:
	CCalculation() : CMeasure(), m_recalc_thread(0), m_info(NULL), m_parent(NULL) { m_selection.m_channel=0; m_selection.m_from=0; m_selection.m_to=0; }
	CCalculation(CMeasure *parent, CSelection &selection) : CMeasure(), m_recalc_thread(0), m_info(NULL) { m_parent=parent; m_selection=selection; }
	~CCalculation() { if (m_info) delete m_info; }
	virtual void CopyResults() { }
	char *GetSourceChannelName() { return m_parent ? m_parent->GetChannelName(m_selection.m_channel) : "Closed"; }
	void ClearThread();
	void StopThread();
	void StartThread(LPTHREAD_START_ROUTINE ThreadProc) { DWORD tid; m_info->reset(); m_recalc_thread=(HANDLE)CreateThread( NULL, 16384, (LPTHREAD_START_ROUTINE)ThreadProc, (void*)m_info, 0, &tid ); }
	void SetParent(CMeasure *doc) { m_parent=doc; }
	CMeasure *GetParent() { return m_parent; }
	CSelection *GetSelection() { return &m_selection; }
	CParametrySygnalu *GetParentSignalParams() { return m_parent ? m_parent->GetSignalParams(m_selection.m_channel) : 0; }
	char *GetChannelName(int channel) { return m_parent ? m_parent->GetSignalParams(m_selection.m_channel)->m_skladowe[channel].m_name : "Closed"; }
	int Calculated() { return m_info->m_calculated; }
	char *GetParentFileName() { return m_parent ? m_parent->GetFileName() : "Closed"; }
	int ThreadActive() { return m_recalc_thread!=NULL; }
	void MeasureClosed(CMeasure *doc) { if (doc==m_parent) m_parent=NULL; }
	virtual void AddComponent(int channel, int sample);
	virtual int SaveText(FILE *f);
};

