//////////////////////////////////////
class CFftData : public CThreadData
{
public:
	int m_inverse;
	int m_limited;
	double m_limit;
	double m_dt;
};
//////////////////////////////////////
struct CParametryFouriera
{
	int m_inverse;
	int m_tuned;
	double m_tune_fr;
	int m_limited;
	double m_limit;
	int m_phase;
	int m_line_plot;
};
//////////////////////////////////////
class CFft : public CCalculation
{
	CParametryFouriera m_parametry_fouriera;

public:
	CFft(CMeasure *parent, CSelection &selection, CParametryFouriera &fft_params);
	void Init();
	void CalcFFT(HWND parent);
	CParametryFouriera *GetFourierParams() { return &m_parametry_fouriera; }
};

////////////////////////////////////////
class CParametryFourieraDlg : public CDialog
{
	CParametryFouriera *m_fft_params;
	CParametryFouriera m_new_fft_params;
	CSelection *m_selection;
	CSelection m_new_selection;

public:
	CParametryFourieraDlg(CParametryFouriera *fft_params, CSelection *selection) : CDialog()
	{ m_fft_params=fft_params; m_new_fft_params=*fft_params; m_selection=selection; m_new_selection=*selection; }
	int Execute(HWND parent) { return CDialog::Execute(parent, IDD_FFT); }
	virtual BOOL OnInitDialog(HWND hWnd);
	virtual BOOL OnOk();
};

////////////////////////////////////////
class CFftWnd : public CMeasureWnd
{
public:
	CFftWnd() : CMeasureWnd() { }
	virtual int Create(int x, int y, int w, int h, HWND parent, DWORD style);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	virtual int OnCreate(LPCREATESTRUCT create_struct);
	virtual void SetDocument(CMeasure *doc);
private:
	void StartCalc();
};
