//////////////////////////////////////
#define LICZBA_FILTROW 4
extern const char nazwa_typu[LICZBA_FILTROW][30];

//////////////////////////////////////
class CKalmanData : public CThreadData
{
public:
	int m_direction;
	double m_rate;
	int m_components;
	double m_fr[MAX_OMEGA];
	double m_Vr[MAX_OMEGA];
	double m_K[MAX_OMEGA];
	double m_eta[MAX_OMEGA];
	int m_filter_type;
	int m_estimate_error;
	double m_observation_error;
	double m_constant_period;
	double m_asymptotic;
	int m_use_damp;
};
////////////////////////////////////////
class CParametryKalmana
{
public:
	double m_observation_error;
	int m_use_damp;
	int m_filter_type;
	int m_estimate_error;
	double m_constant_period;
	double m_asymptotic;
};

//////////////////////////////////////
class CKalman : public CCalculation
{
	CParametryKalmana m_parametry_kalmana;

public:
	CKalman(CMeasure *parent, CSelection &selection, CParametryKalmana &parametry_kalmana);
	void CalcKalman(HWND hParent);
	void Init();
	CParametryKalmana *GetKalmanParams() { return &m_parametry_kalmana; }
	virtual void CopyResults();
};

////////////////////////////////////////
class CParametryKalmanaDlg : public CDialog
{
	BOOL m_byly_zmiany;
	CParametrySygnalu *m_params;
	CParametrySygnalu m_new_params;
	CParametryKalmana *m_kalman_params;
	CParametryKalmana m_new_kalman_params;
	CSelection *m_selection;
	CSelection m_new_selection;

public:
	CParametryKalmanaDlg(CParametrySygnalu *params, CParametryKalmana *kalman_params, CSelection *selection) : CDialog()
	{ m_params=params; m_new_params=*params; m_kalman_params=kalman_params; m_new_kalman_params=*kalman_params; m_selection=selection; m_new_selection=*selection; }
	int Execute(HWND parent) { return CDialog::Execute(parent, IDD_KALMAN); }
	virtual BOOL OnInitDialog(HWND hWnd);
	virtual BOOL OnOk();
	virtual BOOL OnNotify(int id, NMHDR *hdr);
	virtual BOOL OnCommand(int id, int notify, HWND control);

private:
	void fill_param(int i);
	void change_settings();
	void create_columns();
	void delete_component();
	void insert_component();
	void insert(int i);
	void copy_all();
};

////////////////////////////////////////
class CKalmanWnd : public CMeasureWnd
{
public:
	CKalmanWnd() : CMeasureWnd() { }
	virtual int Create(int x, int y, int w, int h, HWND parent, DWORD style);
	virtual LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
	virtual int OnCreate(LPCREATESTRUCT create_struct);
	virtual void SetDocument(CMeasure *doc);
private:
	void StartCalc();
};
